import type { RuleEncodeChannels, WithDefaultEncode, PlotRuleEncoderSpec, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
export declare class Rule extends SemanticMark<PlotRuleEncoderSpec, RuleEncodeChannels> {
    static readonly type = PlotMakType.rule;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    protected parseScaleOfEncodeX(option: ValueOf<WithDefaultEncode<PlotRuleEncoderSpec, RuleEncodeChannels>, RuleEncodeChannels>): ScaleSpec | Nil;
    parseScaleByEncode(channel: RuleEncodeChannels, option: ValueOf<WithDefaultEncode<PlotRuleEncoderSpec, RuleEncodeChannels>, RuleEncodeChannels>): ScaleSpec | Nil;
    convertMarkEncode(encode: WithDefaultEncode<PlotRuleEncoderSpec, RuleEncodeChannels>): GenerateBaseEncodeSpec<PlotRuleEncoderSpec>;
}
